#include "StackAsArray.h"

StackAsArray::StackAsArray(unsigned int size)
	: theArray(size)
{}

void StackAsArray::Purge()
{
	if (IsOwner())
	{
		for (unsigned int i=0; i<count; i++)
			delete theArray[i];
	}
	count = 0;
}

StackAsArray::~StackAsArray()
{ Purge(); }

void StackAsArray::Push(Object& object)
{	
	if (count == theArray.Length())
		throw "Stack is full";
	theArray[count++] = &object;
}

Object& StackAsArray::Pop()
{
	if(count == 0)
		throw "Stack is empty";
	return *theArray[--count];
}

Object& StackAsArray::Top()
{
	if(count == 0)
		throw "Stack is empty";
	return *theArray[count - 1];
}
